<?php
/**
* This module was developed for PrestaShop Addons: http://addons.prestashop.com.
*
* @created   2015-03-20 20:08:00
* @updated   2018-05-19 13:22:00
*
* @author    Daniel Omine <omine@japancase.com>
* @copyright JapanCase - Digital Business
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

class EpsilonPaymentModuleFrontController extends ModuleFrontController
{
    /**
     * @see FrontController::postProcess()
     */
    public function postProcess()
    {
        $cart = $this->context->cart;

echo time().' 1'; print_r($_POST); exit;
        if (
            $cart->id_customer == 0
            || $cart->id_address_delivery == 0
            || $cart->id_address_invoice == 0
            || !$this->module->active
        ) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        /**
        Check that this payment option is still available in case the customer changed his address 
        just before the end of the checkout process
        */
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'epsilon') {
                $authorized = true;
                break;
            }
        }
        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }


        /**
        Protection against duplicated requests.
        Auto redirect to order-history page if an request has done before with current cart id.
        */
        $this->module->checkTransactionRequested($cart->id);

        /**
        Get customer information.
        */
        $customer = new Customer($cart->id_customer);
        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        $currency = $this->context->currency;
        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);
        $mailVars = array(
            //'{epsilon_owner}' => Configuration::get('EPSILON_JC_STORE_ID'),
        );



        $rs = $this->module->transactionRequest($customer, $cart);

        //$rs['gateway']->provider['billing_status']; // 1 provisory, 0 real

        if (!$rs['error']) {

            if ($rs['gateway']->provider['result'] == 1 && $rs['gateway']->provider['billing_status'] < 1) {
                $os = 'EPSILON_OS_ACCEPTED';
            } else {
                $os = 'EPSILON_OS_PROCESSING';
            }

            $this->module->validateOrder(
                $cart->id,
                Configuration::get($os),
                $total,
                $this->module->displayName,
                null,
                $mailVars,
                (int)$currency->id,
                false,
                $customer->secure_key
            );

            /*
            Checking for ACS 3-D Secure
            */
            if (
                $rs['gateway']->provider['result'] == 5
                && !empty($rs['gateway']->provider['acs_pareq'])
                && !empty($rs['gateway']->provider['acs_url'])
            ) {

                //$acs = true;

                $this->context->smarty->assign(array(
                    'frm_action' => $rs['gateway']->provider['acs_url'],
                    'frm_pareq' => $rs['gateway']->provider['acs_pareq'],
                    'frm_md' => $this->module->ACS3DSecureMDMount(
                        $cart->id,
                        $rs['data']['order_number'],
                        $rs['data']['jc_store_id']
                    ),
                    'frm_termurl' => $this->context->link->getModuleLink($this->module->name, 'acs'),
                    'p_pareq' => Epsilon::P_PAREQ,
                    'p_md' => Epsilon::P_MD,
                    'p_termurl' => Epsilon::P_TERMURL
                ));

                $this->setTemplate('acs_form.tpl');
                return null;

            }
            //http://kwski.net/lab/creditcardvalidator
        } else {
            //https://www.prestashop.com/forums/topic/400110-how-to-save-messages-to-be-shown-after-redirect/
            $this->context->cookie->__set($this->module->name.'_errors', Tools::displayError($rs['error_detail']));
            //echo '123'; print_r($rs['error_detail']); echo '123'; exit;
            //$this->context->cookie->__set($this->module->name.'_errors', $rs['error_detail']);

            /*
            Redirect back to the payment page.
            */
            Tools::redirect($this->context->link->getModuleLink($this->module->name, 'payment'));
        }
echo time().'LAST'; exit;
        /*
        When the process completed successfuly.
        Check the method Epsilon::hookPaymentReturn();
        */
        Tools::redirect(
            'index.php?controller=order-confirmation&id_cart='.$cart->id.'&id_module='.$this->module->id
            .'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key
        );
    }
}
