<?php
/**
* @brief  Library for PHP CURL.
* @date   2011-01-10 12:10:00
* @license http://opensource.org/licenses/GPL-3.0 GNU Public License
* @company: JapanCase.com
* @author: Daniel Omine <omine@japancase.com>
* @updated: 2012-09-12 02:19:00
*/

class JcCurl
{

    public static $Result;
    public static $Error;
    public static $ErrorMsg;
    public static $fields  = false;
	public static $conf = false;
	protected static $extr = false;

	public static function Set($a)
	{
		$p = 'PORT';           self::$conf[CURLOPT_PORT]           = isset( $a[$p] ) ? $a[$p] : 80;
		$p = 'METHOD';         self::$extr[$p]                     = isset( $a[$p] ) ? $a[$p] : 'GET';
		$p = 'URL';            self::$conf[CURLOPT_URL]            = isset( $a[$p] ) ? $a[$p] : '127.0.0.1';
		$p = 'URL_APPEND';     self::$extr[$p]                     = isset( $a[$p] ) ? $a[$p] : false;
		$p = 'ENCODE_DATA';    self::$extr[$p]                     = isset( $a[$p] ) ? $a[$p] : 1;
		$p = 'TIMEOUT';        self::$conf[CURLOPT_TIMEOUT]        = isset( $a[$p] ) ? $a[$p] : 5;
		$p = 'HEADER';         self::$conf[CURLOPT_HEADER]         = isset( $a[$p] ) ? $a[$p] : false;
		$p = 'MAXREDIRS';      self::$conf[CURLOPT_MAXREDIRS]      = isset( $a[$p] ) ? $a[$p] : 1;
		$p = 'REFERER';        self::$conf[CURLOPT_REFERER]        = isset( $a[$p] ) ? $a[$p] : 'http://' . $_SERVER['SERVER_NAME'];
		$p = 'USER_AGENT';     self::$conf[CURLOPT_USERAGENT]      = isset( $a[$p] ) ? $a[$p] : 'Mozilla/5.0 (Windows NT 6.2; WOW64) AppleWebKit/537.1 (KHTML, like Gecko) Chrome/21.0.1180.89 Safari/537.1';
		$p = 'HTTPAUTH';       self::$conf[CURLOPT_HTTPAUTH]       = isset( $a[$p] ) ? $a[$p] : false;  // CURLAUTH_NTLM, CURLAUTH_BASIC, CURLAUTH_DIGEST
		$p = 'USERPWD';        self::$conf[CURLOPT_USERPWD]        = isset( $a[$p] ) ? $a[$p] : false;  // user pass.. if HTTPAUTH is true, must unset()
		$p = 'CONNECTTIMEOUT'; self::$conf[CURLOPT_CONNECTTIMEOUT] = isset( $a[$p] ) ? $a[$p] : 5;
		//$p = 'CONNECTTIMEOUT_MS'; self::$conf[CURLOPT_CONNECTTIMEOUT_MS] = isset( $a[$p] ) ? $a[$p] : ( self::$conf[CURLOPT_CONNECTTIMEOUT] * 1000 );
		$p = 'RETURNTRANSFER'; self::$conf[CURLOPT_RETURNTRANSFER] = isset( $a[$p] ) ? $a[$p] : true;   // return web page 
		$p = 'FOLLOWLOCATION'; self::$conf[CURLOPT_FOLLOWLOCATION] = isset( $a[$p] ) ? $a[$p] : false;  // follow redirects
		$p = 'ENCODING';       self::$conf[CURLOPT_ENCODING]       = isset( $a[$p] ) ? $a[$p] : '';     // if empty, handle all encodings 
		$p = 'AUTOREFERER';    self::$conf[CURLOPT_AUTOREFERER]    = isset( $a[$p] ) ? $a[$p] : false;   // set referer on redirect 
		$p = 'SSL_VERIFYHOST'; self::$conf[CURLOPT_SSL_VERIFYHOST] = isset( $a[$p] ) ? $a[$p] : 0;      // don't verify ssl
		$p = 'SSL_VERIFYPEER'; self::$conf[CURLOPT_SSL_VERIFYPEER] = isset( $a[$p] ) ? $a[$p] : false;  // 
		$p = 'VERBOSE';        self::$conf[CURLOPT_VERBOSE]        = isset( $a[$p] ) ? $a[$p] : 1;      // 
		/**
		Avoid the constant CURL_SSLVERSION_TLSv1 (int 1), due to security standards.
		The constant CURL_SSLVERSION_TLSv1_2 not available in PHP versions prior to 5.5. To avoid problems, use the integer value 6.
		*/
		$p = 'SSLVERSION';     self::$conf[CURLOPT_SSLVERSION]     = isset( $a[$p] ) ? $a[$p] : 6;      // 

		$p = 'CAINFO';         self::$conf[CURLOPT_CAINFO]         = isset( $a[$p] ) ? $a[$p] : false;  //  path to ssl certificate

		//$p = 'SAFE_UPLOAD';    self::$conf[CURLOPT_SAFE_UPLOAD]    = isset( $a[$p] ) ? $a[$p] : false;  // introduced in php5.0
		//http://stackoverflow.com/questions/25934128/curl-file-uploads-not-working-anymore-after-upgrade-from-php-5-5-to-5-6
		//https://www.axivo.com/threads/curl-issues-with-php-5-6.93/


		return new self();
	}

    public static function Request()
    {
        self::$Error    = false;
        self::$ErrorMsg = false;
		/*
		echo CURLOPT_PORT . PHP_EOL;
		echo CURLOPT_URL . PHP_EOL;
		echo CURLOPT_TIMEOUT . PHP_EOL;
		echo CURLOPT_HEADER . PHP_EOL;
		echo CURLOPT_MAXREDIRS . PHP_EOL;
		echo CURLOPT_REFERER . PHP_EOL;
		echo CURLOPT_USERAGENT . PHP_EOL;
		echo CURLOPT_HTTPAUTH . PHP_EOL;
		echo CURLOPT_USERPWD . PHP_EOL;
		echo CURLOPT_CONNECTTIMEOUT . PHP_EOL;
		echo CURLOPT_RETURNTRANSFER . PHP_EOL;
		echo CURLOPT_FOLLOWLOCATION . PHP_EOL;
		echo CURLOPT_ENCODING . PHP_EOL;
		echo CURLOPT_AUTOREFERER . PHP_EOL;
		echo CURLOPT_SSL_VERIFYHOST . PHP_EOL;
		echo CURLOPT_SSL_VERIFYPEER . PHP_EOL;
		echo CURLOPT_SSLVERSION . PHP_EOL;
		echo CURLOPT_VERBOSE . PHP_EOL;
		echo CURLOPT_SSLVERSION; //exit;
		*/
		//var_dump( self::$conf ); exit;
		//echo time(); exit;

		if (!self::$conf) {
			self::Set(array());
		}
        if (!self::$conf[CURLOPT_SSL_VERIFYPEER]) {
			unset(self::$conf[CURLOPT_CAINFO]);
		}
        if (!self::$conf[CURLOPT_USERPWD]) {
			if (isset(self::$conf[CURLOPT_HTTPAUTH])) {
				unset(self::$conf[CURLOPT_HTTPAUTH]);
			}
        }

		//var_dump( self::$conf ); exit;

        if (self::$fields && is_array(self::$fields)) {
            $s = 0;
            switch (self::$extr['METHOD']) {
                default:
                case 'GET':
                    self::$conf[CURLOPT_HTTPGET] = true;
                    self::$conf[CURLOPT_URL]    .= '?';
					$i = false;
                    foreach (self::$fields as $k => $v) {
						$p  = $i ? '&':'';
                        $p .= $k . '=' . urlencode($v);
                        $s += strlen( $p );
                        self::$conf[CURLOPT_URL] .= $p;
						$i = true;
                    }
                    $s = strlen($p);
					//echo self::$conf[CURLOPT_URL]; exit;
                break;
                case 'POST':
                    self::$conf[CURLOPT_POST]    = 1;
                    //print_r( self::$fields ); exit;
                    if(self::$extr['ENCODE_DATA'] == 2) {
                        self::$conf[CURLOPT_POSTFIELDS]  = self::$fields;
                    } else {
                        self::$conf[CURLOPT_POSTFIELDS] = '';
                        foreach (self::$fields as $k => $v) {
                            self::$conf[CURLOPT_POSTFIELDS] .= $k.'='.urlencode($v).'&';
                        }
                        $s = strlen(self::$conf[CURLOPT_POSTFIELDS]);
                    }
                break;
            }
            if ($s > 0) {
				// infinite loop on db.bomprecoserver... 2012-09-12
                //self::$conf[CURLOPT_HTTPHEADER] = array( 'Content-Type: text/xml; charset=ISO-8859-1', 'Content-length: ' . $s );
            }

        }
        
		if (self::$extr['URL_APPEND']) {
			self::$conf[CURLOPT_URL] .= self::$extr['URL_APPEND'];
		}

		//var_dump( self::$conf ); exit;
		//echo __FILE__ . ' ' . PHP_EOL . file_get_contents( self::$conf[CURLOPT_URL] ); exit;
        //print_r( self::$conf ); exit;

        $ch = curl_init();
		//var_dump( self::$conf ); exit;
        curl_setopt_array( $ch, self::$conf );

		/*
		// debug purposes only
				foreach (self::$conf as $k => $v) {
					if (!curl_setopt($ch, $k, $v)) {
						//echo $k . ': ' . time(); exit;
					}
				}
		*/

        try {
            $content = curl_exec($ch);
            $err     = curl_errno($ch); 
            $errmsg  = curl_error($ch) ; 
            $header  = curl_getinfo($ch); 
            curl_close($ch); 
            //echo time(); exit;
            $header['errno']   = $err; 
            $header['errmsg']  = $errmsg; 
            $header['content'] = $content; 
//var_dump( $header ); exit;
            if ($header['errno'] == 0) {

                if ($header['http_code'] == 200) {
                    //echo time(); exit;
                    self::$Result = $header['content'];
                } else {
                    self::$Error = $header;
                }

            } else {
                self::$Error = $header;
            }

        } catch (HttpException $ex) {
            self::$Error['exception'] = $ex;
            self::$ErrorMsg = self::$Error['exception'];
        }

        return null;
    }

    public static function Reset($all = false)
    {
        self::$Result = false;
        self::$Error = false;
        self::$ErrorMsg = false;
        
        self::$fields = false;
		if ($all) {
			self::$conf = false;
		}
    }

	/*
	// usage sample

	include('DAOURL.php');

	$arr['PORT']            = '7788';
	$arr['TIMEOUT']         = 7;
	$arr['HEADER']          = true;
	$arr['MAXREDIRS']       = 1;
	$arr['REFERER']         = 'http://foo.bar';
	$arr['USER_AGENT']      = 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)';
	$arr['USERPWD']         = false;
	$arr['HTTPAUTH']        = false; // HTTP_AUTH_NTLM, CURLAUTH_BASIC
	$arr['METHOD']          = 'GET';
	$arr['CONNECTTIMEOUT']  = 7;
	$arr['ENCODE_DATA']     = 1;

	$c = new DAOURL( $arr );
	//$c::$conf = $arr; 
	$c -> url_append = '';
	$c -> url        = '69.64.56.138';
	$c -> Request();

	if( !$c -> Error )
	{
		echo $c -> Result; exit;
	}else{
		//print_r( $c -> Error ); exit;
		self::$error = $c -> ErrorMsg; 
		//exit;
	}

	*/
}
