{*
* This module was developed for PrestaShop Addons: http://addons.prestashop.com.
*
* @created   2015-03-20 20:08:00
* @updated   2016-01-17 03:16:00
*
* @author    Daniel Omine <omine@japancase.com>
* @copyright JapanCase - Digital Business
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*}

<br />

{if !$epsilon_state_canceled}

<script type="text/javascript">
{literal}
// <![CDATA[

function GatewayResult(action, obj)
{

	if( obj.error ){
		/*
		This module
		*/
		msg = '{/literal}{l s='WARN: ' mod='epsilon'}{literal}' + obj.error;
		if (obj.hasOwnProperty('error_message') && obj.error_message) {
			return obj.error_message;
			msg += ' ' + obj.error_message;	
		}
		return msg;
	}

	if (obj.hasOwnProperty('gateway') && obj.gateway) {

		/*
		JapanCase API (Gateway)
		*/
		if (obj.gateway.hasOwnProperty('error') && obj.gateway.error) {
			return '{/literal}{l s='GATEWAY WARN: ' mod='epsilon'}{literal}' + obj.gateway.error;
		}

		/*
		Epsilon API (Provider)
		*/
		if (obj.gateway.hasOwnProperty('provider') && obj.gateway.provider) {
			if (obj.gateway.provider.hasOwnProperty('error_code') && obj.gateway.provider.error_code) {
				msg = '{/literal}{l s='EPSILON WARN: ' mod='epsilon'}{literal}' + obj.gateway.provider.error_code;
				if (obj.gateway.provider.hasOwnProperty('error_detail') && obj.gateway.provider.error_detail) {
					msg += ' ' + obj.gateway.provider.error_detail;				
				}
				return msg;
			}
		}
	}

	var provider = null;
	if (obj.gateway.hasOwnProperty('provider') && obj.gateway.provider) {
		provider = obj.gateway.provider;
	}

	if (provider.hasOwnProperty('result') && provider.result == 1) {

		msg = 'unknown status code (provider.result): '+provider.result;
		refresh = false;

		switch(action)
		{
			case 'real_sale':
				msg = '{/literal}{l s='The payment was billed' mod='epsilon'}{literal}';
				refresh = true;
			break;
			case 'amount_change':
				msg = '{/literal}{l s='The payment amount was changed' mod='epsilon'}{literal}';
				refresh = true;
			break;
			case 'cancel':
				msg = '{/literal}{l s='The payment was canceled' mod='epsilon'}{literal}';
				refresh = true;
			break;
		}

		if (refresh)
			window.location.href = window.location.href+'&epsilont='+time()+'#epsilon';

		return msg;
	}

	return '';
}

function GatewayRequest(action)
{

	$('#epsilon_loading_status').show();
	$('#epsilon_ajax_response').text('{/literal}{l s='Loading the request. Please, do not leave this page.' mod='epsilon'}{literal}');

	switch(action)
	{
		case 'real_sale':
			action_parameter = 'RealSaleRequest';
		break;
		case 'amount_change':
			action_parameter = 'AmountChangeRequest';
		break;
		case 'cancel':
			action_parameter = 'CancelRequest';
			if(!confirm('{/literal}{l s='Do you really want cancel the payment?' mod='epsilon'}{literal}'))
			{
				//console.log('action aborted');
				$('#epsilon_ajax_response').text('');
				$('#epsilon_loading_status').hide();
				return null;
			}
		break;
	}

	$.ajax({
		url: 'index.php?controller=AdminModules&ajax&configure=epsilon&tab_module=payments_gateways&module_name=epsilon&token={/literal}{$ajax_token|escape:'htmlall':'UTF-8'}{literal}',
		type: 'GET',
		cache: false,
		data: {ps_id_cart:{/literal}{$id_cart|escape:'htmlall':'UTF-8'}{literal}, action:action_parameter},
		//async:false,
		success: function(data) {
			console.log(data);
			if( obj = $.parseJSON(data) )
			{

				$('#epsilon_ajax_response').text(GatewayResult(action, obj));
				$('#epsilon_loading_status').hide();

			}else{
				$('#epsilon_ajax_response').text('{/literal}{l s='Internal error: Ajax request' mod='epsilon'}{literal}');
			}
		}
	});
}

$().ready(function() {

	$('#epsilon_loading_status').hide();

	$.ajaxSetup({ cache: false });
{/literal}
{if !$epsilon_state_canceled}
{literal}
	$('#epsilon_action_real_sale').click(function(event) {
		GatewayRequest('real_sale');
	});
	$('#epsilon_action_amount_change').click(function(event) {
		GatewayRequest('amount_change');
	});
	$('#epsilon_action_cancel').click(function(event) {
		GatewayRequest('cancel');
	});
{/literal}
{/if}
{literal}
});


var time = Date.now || function() {
  return +new Date;
};

time();

{/literal}
//]]>
</script>

{/if}

<style>


#epsilon_ajax_response {
	color: #ff0000;
	font-size: 14px;
}

#epsilon_loading_status {
	display: inline;
	vertical-align: middle;
}

.epsilon_actions_btn {
	display: inline;
	background: #ffcc66;
	background-image: -webkit-linear-gradient(top, #ffcc66, #ffff99);
	background-image: -moz-linear-gradient(top, #ffcc66, #ffff99);
	background-image: -ms-linear-gradient(top, #ffcc66, #ffff99);
	background-image: -o-linear-gradient(top, #ffcc66, #ffff99);
	background-image: linear-gradient(to bottom, #ffcc66, #ffff99);
	-webkit-border-radius: 28;
	-moz-border-radius: 28;
	border-radius: 28px;
	font-family: Arial;
	color: #ffffff;
	font-size: 14px;
	padding: 10px 20px 10px 20px;
	text-decoration: none;
}

.epsilon_actions_btn:hover {
	background: #3cb0fd;
	background-image: -webkit-linear-gradient(top, #3cb0fd, #3498db);
	background-image: -moz-linear-gradient(top, #3cb0fd, #3498db);
	background-image: -ms-linear-gradient(top, #3cb0fd, #3498db);
	background-image: -o-linear-gradient(top, #3cb0fd, #3498db);
	background-image: linear-gradient(to bottom, #3cb0fd, #3498db);
	text-decoration: none;
}

.epsilon_buttons_info_blocks{
	display: inline-block;
	padding: 10px 10px 10px 10px;
	font-size: 14px;
}

.epsilon_log_title{
	color: #3cb0fd;
	display: block;
	font-size: 14px;
}

.epsilon_logs td{
	padding: 4px;
	border: 1px solid #ffcc66;
}
.epsilon_logs tr{
	border: 1px solid gray;
	text-align:center;
}
.epsilon_logs tr:hover{
	border: 1px solid blue;
	background: #ffffcc;
}

.inline{
display: inline;
}
.vmiddle{
vertical-align: middle;
}

</style>
<div class="panel">
	<img src="../modules/epsilon/views/img/epsilon_gmo.gif" style=" margin-right:5px;" width="auto" height="50"><br /><br />

	{if !$epsilon_state_canceled}
	<img id="epsilon_loading_status" src="../modules/epsilon/views/img/loading.gif" style=" margin-right:5px;" width="auto" height="30" /> <div id="epsilon_ajax_response"></div><br /><br />
	{/if}

	<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/paid.gif" style=" margin-right:5px;" width="auto" height="35" /> <a href="javascript:;" id="epsilon_action_real_sale" class="epsilon_actions_btn">{l s='ORDER BILLING' mod='epsilon'}</a>
	<div class="epsilon_buttons_info_blocks">{l s='Send request to billing the order. The transaction will be billed if not in test mode. However, still able to change the amount or cancel the transaction.' mod='epsilon'}</div>


	<br clear="all" /><br /><br />
	<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/amount_change.gif" style=" margin-right:5px;" width="auto" height="35" /><a href="javascript:;" id="epsilon_action_amount_change" class="epsilon_actions_btn">{l s='ORDER AMOUNT CHANGE' mod='epsilon'}</a>
	<div class="epsilon_buttons_info_blocks">{l s='Change the transaction total amount.' mod='epsilon'}</div>


	<br clear="all" /><br /><br />
	<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/cancel.gif" style=" margin-right:5px;" width="auto" height="35" /><a href="javascript:;" id="epsilon_action_cancel" class="epsilon_actions_btn">{l s='CANCEL PAYMENT' mod='epsilon'}</a>
	<div class="epsilon_buttons_info_blocks">{l s='Cancel the transaction. Once canceled, cannot change the amount or request billing. Please, acknowledge.' mod='epsilon'}</div>

	
	{if $epsilon_log}
		<br /><br /><br /><div class="epsilon_log_title">{l s='TRANSACTION LOG' mod='epsilon'} ({$id_cart|escape:'htmlall':'UTF-8'})</div>
		{assign var="last_date" value=false}
		{assign var="last_time" value=false}
		<table class="epsilon_logs">
		<tr>
		<td>{l s='Hour' mod='epsilon'}<a name="epsilon"></a></td>
		<td>
		<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/request.gif" style=" margin-right:3px;" width="auto" height="17" />{l s='Request' mod='epsilon'}
		<br /><img class="inline vmiddle" src="../modules/epsilon/views/img/icons/response.gif" style=" margin-right:3px;" width="auto" height="17" />{l s='Response' mod='epsilon'}</td>
		<td>{l s='Action' mod='epsilon'}</td>
		<td>{l s='Card' mod='epsilon'}</td>
		<td>{l s='Amount' mod='epsilon'}</td>
		<td>{l s='Result' mod='epsilon'}</td>
		<td>{l s='Error Code' mod='epsilon'}</td>
		<td>{l s='Error Detail' mod='epsilon'}</td>
		<td>{l s='3-DSecure PaReq' mod='epsilon'}</td>
		<td>{l s='3-DSecure PaRes' mod='epsilon'}</td>
		<td>{l s='Epsilon ID' mod='epsilon'}</td>
		<td>{l s='TEST MODE' mod='epsilon'}</td>
		</tr>
		{foreach from=$epsilon_log item=v key=k}
			{assign var="row_date" value=$v.date_created|substr:0:10}
			{assign var="row_time" value=$v.date_created|substr:11}
			{if $last_date != $row_date}
				<td colspan="12">{$row_date|escape:'htmlall':'UTF-8'}</td></tr><tr title="status: {$v.status|escape:'htmlall':'UTF-8'}, contract_code: {$v.provider_contract_code|escape:'htmlall':'UTF-8'}">
				{assign var="last_date" value=$row_date}
			{else}
			<tr title="status: {$v.status|escape:'htmlall':'UTF-8'}, contract_code: {$v.provider_contract_code|escape:'htmlall':'UTF-8'}">
			{/if}
			<td>
			{$row_time|escape:'htmlall':'UTF-8'}
			</td>
			{if $v.status|strlen == 2}
				{assign var="img" value="request"}
			{else}
				{assign var="img" value="response"}				
			{/if}
			<td>
			<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/{$img|escape:'htmlall':'UTF-8'}.gif" width="auto" height="25" />
			</td>

			{if $v.status|substr:0:2 == $epsilon_transaction_amount_change_request}
				{assign var="img" value="amount_change"}	
			{else if $v.status|substr:0:2 == $epsilon_transaction_cancel_request}
				{assign var="img" value="cancel"}	
			{else if $v.status|substr:0:2 == $epsilon_transaction_real_sale_request}
				{assign var="img" value="paid"}
			{else if $v.status|substr:0:2 == $epsilon_transaction_3ds_pares_request or $v.status|substr:0:2 == $epsilon_transaction_3ds_pares_response}
				{assign var="img" value="epsilon_os_3ds"}
			{else}
				{assign var="img" value=""}
			{/if}
			<td>
			{if $img}
				{if $v.status|substr:0:2 != $epsilon_transaction_request}
				<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/{$img|escape:'htmlall':'UTF-8'}.gif" width="auto" height="25" />
				{/if}
			{/if}
			</td>
			<td>
			{if $v.client_pay_method}
				<img src="../modules/epsilon/views/img/icons/cards/{if $v.jc_debug_urls == 1}visa.gif{else}{$epsilon_card_brands[$v.client_pay_method]['ico']|escape:'htmlall':'UTF-8'}{/if}" width="auto" height="25" alt="{$epsilon_card_brands[$v.client_pay_method]['brand']|escape:'htmlall':'UTF-8'}" title="{$epsilon_card_brands[$v.client_pay_method]['brand']|escape:'htmlall':'UTF-8'}" />
			{/if}
			</td>
			<td>
			{if $v.client_order_amount}
				¥{$v.client_order_amount|number_format:0:",":"."|escape:'htmlall':'UTF-8'}
			{/if}
			</td>
			<td>
				{if $v.pay_provider_result == 1}
					{if $v.status == $epsilon_transaction_real_sale_response || ($v.status == $epsilon_transaction_response && $v.pay_provider_billing_status == $epsilon_transaction_status_billed)}
						<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/billed.gif" width="auto" height="25" title="{l s='Billed' mod='epsilon'}" />
					{else}
						<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/ok.png" width="auto" height="25" title="{l s='Accepted' mod='epsilon'}" />
					{/if}
				{else}
					{if $v.pay_provider_error_code}
					<img class="inline vmiddle" src="../modules/epsilon/views/img/icons/ng.png" width="auto" height="25" title="{l s='Denied' mod='epsilon'}" />
					<br />
					{/if}
					{$v.pay_provider_result|escape:'htmlall':'UTF-8'}
				{/if}
			</td>
			<td>
			{$v.pay_provider_error_code|escape:'htmlall':'UTF-8'}
			</td>
			<td>
			{$v.pay_provider_error_detail|escape:'htmlall':'UTF-8'}
			</td>
			<td>
			{$v.acs_pareq|escape:'htmlall':'UTF-8'}
			</td>
			<td>
			{$v.acs_pares|escape:'htmlall':'UTF-8'}
			</td>
			<td>
			{$v.client_order_id|escape:'htmlall':'UTF-8'}
			</td>
			<td>
			{$v.jc_debug_urls|escape:'htmlall':'UTF-8'}
			</td>
			</tr>
		{/foreach}
		</table>
		{l s='*To see new log entries, please, reload this page' mod='epsilon'}
	{/if}
</div>